<?php

namespace Webservice\Service\Dto\SmevSoap\Struct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormDataResponseType Struct
 * Meta information extracted from the WSDL
 * - documentation: Ответ с изменением статуса заявления или информация о последовательности предоставления мест или информация об основаниях
 * изменения последовательности предоставления мест или ответ с данными заявления для редактирования или ответ с данными для подачи
 * заявления на приём или ответ на запрос отмены заявления
 * @subpackage Structs
 */
class FormDataResponseType extends AbstractStructBase
{
    /**
     * The changeOrderInfo
     * Meta information extracted from the WSDL
     * - choice: changeOrderInfo | GetApplicationQueueResponse | GetApplicationQueueReasonResponse | GetApplicationResponse | GetApplicationAdmissionResponse | cancelResponse
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Webservice\Service\Dto\SmevSoap\Struct\ChangeOrderInfoType
     */
    public $changeOrderInfo;
    /**
     * The GetApplicationQueueResponse
     * Meta information extracted from the WSDL
     * - choice: changeOrderInfo | GetApplicationQueueResponse | GetApplicationQueueReasonResponse | GetApplicationResponse | GetApplicationAdmissionResponse | cancelResponse
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Webservice\Service\Dto\SmevSoap\Struct\ApplicationQueueResponseType
     */
    public $GetApplicationQueueResponse;
    /**
     * The GetApplicationQueueReasonResponse
     * Meta information extracted from the WSDL
     * - choice: changeOrderInfo | GetApplicationQueueResponse | GetApplicationQueueReasonResponse | GetApplicationResponse | GetApplicationAdmissionResponse | cancelResponse
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationQueueReasonResponseType
     */
    public $GetApplicationQueueReasonResponse;
    /**
     * The GetApplicationResponse
     * Meta information extracted from the WSDL
     * - choice: changeOrderInfo | GetApplicationQueueResponse | GetApplicationQueueReasonResponse | GetApplicationResponse | GetApplicationAdmissionResponse | cancelResponse
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationResponseType
     */
    public $GetApplicationResponse;
    /**
     * The GetApplicationAdmissionResponse
     * Meta information extracted from the WSDL
     * - choice: changeOrderInfo | GetApplicationQueueResponse | GetApplicationQueueReasonResponse | GetApplicationResponse | GetApplicationAdmissionResponse | cancelResponse
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationAdmissionResponseType
     */
    public $GetApplicationAdmissionResponse;
    /**
     * The cancelResponse
     * Meta information extracted from the WSDL
     * - choice: changeOrderInfo | GetApplicationQueueResponse | GetApplicationQueueReasonResponse | GetApplicationResponse | GetApplicationAdmissionResponse | cancelResponse
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Webservice\Service\Dto\SmevSoap\Struct\CancelResponseType
     */
    public $cancelResponse;
    /**
     * Constructor method for FormDataResponseType
     * @uses FormDataResponseType::setChangeOrderInfo()
     * @uses FormDataResponseType::setGetApplicationQueueResponse()
     * @uses FormDataResponseType::setGetApplicationQueueReasonResponse()
     * @uses FormDataResponseType::setGetApplicationResponse()
     * @uses FormDataResponseType::setGetApplicationAdmissionResponse()
     * @uses FormDataResponseType::setCancelResponse()
     * @param \Webservice\Service\Dto\SmevSoap\Struct\ChangeOrderInfoType $changeOrderInfo
     * @param \Webservice\Service\Dto\SmevSoap\Struct\ApplicationQueueResponseType $getApplicationQueueResponse
     * @param \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationQueueReasonResponseType $getApplicationQueueReasonResponse
     * @param \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationResponseType $getApplicationResponse
     * @param \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationAdmissionResponseType $getApplicationAdmissionResponse
     * @param \Webservice\Service\Dto\SmevSoap\Struct\CancelResponseType $cancelResponse
     */
    public function __construct(\Webservice\Service\Dto\SmevSoap\Struct\ChangeOrderInfoType $changeOrderInfo = null, \Webservice\Service\Dto\SmevSoap\Struct\ApplicationQueueResponseType $getApplicationQueueResponse = null, \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationQueueReasonResponseType $getApplicationQueueReasonResponse = null, \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationResponseType $getApplicationResponse = null, \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationAdmissionResponseType $getApplicationAdmissionResponse = null, \Webservice\Service\Dto\SmevSoap\Struct\CancelResponseType $cancelResponse = null)
    {
        $this
            ->setChangeOrderInfo($changeOrderInfo)
            ->setGetApplicationQueueResponse($getApplicationQueueResponse)
            ->setGetApplicationQueueReasonResponse($getApplicationQueueReasonResponse)
            ->setGetApplicationResponse($getApplicationResponse)
            ->setGetApplicationAdmissionResponse($getApplicationAdmissionResponse)
            ->setCancelResponse($cancelResponse);
    }
    /**
     * Get changeOrderInfo value
     * @return \Webservice\Service\Dto\SmevSoap\Struct\ChangeOrderInfoType|null
     */
    public function getChangeOrderInfo()
    {
        return isset($this->changeOrderInfo) ? $this->changeOrderInfo : null;
    }
    /**
     * This method is responsible for validating the value passed to the setChangeOrderInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangeOrderInfo method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateChangeOrderInfoForChoiceConstraintsFromSetChangeOrderInfo($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'GetApplicationQueueResponse',
            'GetApplicationQueueReasonResponse',
            'GetApplicationResponse',
            'GetApplicationAdmissionResponse',
            'cancelResponse',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property changeOrderInfo can\'t be set as the property %s is already set. Only one property must be set among these properties: changeOrderInfo, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set changeOrderInfo value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Webservice\Service\Dto\SmevSoap\Struct\ChangeOrderInfoType $changeOrderInfo
     * @return \Webservice\Service\Dto\SmevSoap\Struct\FormDataResponseType
     */
    public function setChangeOrderInfo(\Webservice\Service\Dto\SmevSoap\Struct\ChangeOrderInfoType $changeOrderInfo = null)
    {
        // validation for constraint: choice(changeOrderInfo, GetApplicationQueueResponse, GetApplicationQueueReasonResponse, GetApplicationResponse, GetApplicationAdmissionResponse, cancelResponse)
        if ('' !== ($changeOrderInfoChoiceErrorMessage = self::validateChangeOrderInfoForChoiceConstraintsFromSetChangeOrderInfo($changeOrderInfo))) {
            throw new \InvalidArgumentException($changeOrderInfoChoiceErrorMessage, __LINE__);
        }
        if (is_null($changeOrderInfo) || (is_array($changeOrderInfo) && empty($changeOrderInfo))) {
            unset($this->changeOrderInfo);
        } else {
            $this->changeOrderInfo = $changeOrderInfo;
        }
        return $this;
    }
    /**
     * Get GetApplicationQueueResponse value
     * @return \Webservice\Service\Dto\SmevSoap\Struct\ApplicationQueueResponseType|null
     */
    public function getGetApplicationQueueResponse()
    {
        return isset($this->GetApplicationQueueResponse) ? $this->GetApplicationQueueResponse : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGetApplicationQueueResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetApplicationQueueResponse method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGetApplicationQueueResponseForChoiceConstraintsFromSetGetApplicationQueueResponse($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'changeOrderInfo',
            'GetApplicationQueueReasonResponse',
            'GetApplicationResponse',
            'GetApplicationAdmissionResponse',
            'cancelResponse',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property GetApplicationQueueResponse can\'t be set as the property %s is already set. Only one property must be set among these properties: GetApplicationQueueResponse, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set GetApplicationQueueResponse value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Webservice\Service\Dto\SmevSoap\Struct\ApplicationQueueResponseType $getApplicationQueueResponse
     * @return \Webservice\Service\Dto\SmevSoap\Struct\FormDataResponseType
     */
    public function setGetApplicationQueueResponse(\Webservice\Service\Dto\SmevSoap\Struct\ApplicationQueueResponseType $getApplicationQueueResponse = null)
    {
        // validation for constraint: choice(changeOrderInfo, GetApplicationQueueResponse, GetApplicationQueueReasonResponse, GetApplicationResponse, GetApplicationAdmissionResponse, cancelResponse)
        if ('' !== ($getApplicationQueueResponseChoiceErrorMessage = self::validateGetApplicationQueueResponseForChoiceConstraintsFromSetGetApplicationQueueResponse($getApplicationQueueResponse))) {
            throw new \InvalidArgumentException($getApplicationQueueResponseChoiceErrorMessage, __LINE__);
        }
        if (is_null($getApplicationQueueResponse) || (is_array($getApplicationQueueResponse) && empty($getApplicationQueueResponse))) {
            unset($this->GetApplicationQueueResponse);
        } else {
            $this->GetApplicationQueueResponse = $getApplicationQueueResponse;
        }
        return $this;
    }
    /**
     * Get GetApplicationQueueReasonResponse value
     * @return \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationQueueReasonResponseType|null
     */
    public function getGetApplicationQueueReasonResponse()
    {
        return isset($this->GetApplicationQueueReasonResponse) ? $this->GetApplicationQueueReasonResponse : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGetApplicationQueueReasonResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetApplicationQueueReasonResponse method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGetApplicationQueueReasonResponseForChoiceConstraintsFromSetGetApplicationQueueReasonResponse($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'changeOrderInfo',
            'GetApplicationQueueResponse',
            'GetApplicationResponse',
            'GetApplicationAdmissionResponse',
            'cancelResponse',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property GetApplicationQueueReasonResponse can\'t be set as the property %s is already set. Only one property must be set among these properties: GetApplicationQueueReasonResponse, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set GetApplicationQueueReasonResponse value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationQueueReasonResponseType $getApplicationQueueReasonResponse
     * @return \Webservice\Service\Dto\SmevSoap\Struct\FormDataResponseType
     */
    public function setGetApplicationQueueReasonResponse(\Webservice\Service\Dto\SmevSoap\Struct\GetApplicationQueueReasonResponseType $getApplicationQueueReasonResponse = null)
    {
        // validation for constraint: choice(changeOrderInfo, GetApplicationQueueResponse, GetApplicationQueueReasonResponse, GetApplicationResponse, GetApplicationAdmissionResponse, cancelResponse)
        if ('' !== ($getApplicationQueueReasonResponseChoiceErrorMessage = self::validateGetApplicationQueueReasonResponseForChoiceConstraintsFromSetGetApplicationQueueReasonResponse($getApplicationQueueReasonResponse))) {
            throw new \InvalidArgumentException($getApplicationQueueReasonResponseChoiceErrorMessage, __LINE__);
        }
        if (is_null($getApplicationQueueReasonResponse) || (is_array($getApplicationQueueReasonResponse) && empty($getApplicationQueueReasonResponse))) {
            unset($this->GetApplicationQueueReasonResponse);
        } else {
            $this->GetApplicationQueueReasonResponse = $getApplicationQueueReasonResponse;
        }
        return $this;
    }
    /**
     * Get GetApplicationResponse value
     * @return \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationResponseType|null
     */
    public function getGetApplicationResponse()
    {
        return isset($this->GetApplicationResponse) ? $this->GetApplicationResponse : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGetApplicationResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetApplicationResponse method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGetApplicationResponseForChoiceConstraintsFromSetGetApplicationResponse($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'changeOrderInfo',
            'GetApplicationQueueResponse',
            'GetApplicationQueueReasonResponse',
            'GetApplicationAdmissionResponse',
            'cancelResponse',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property GetApplicationResponse can\'t be set as the property %s is already set. Only one property must be set among these properties: GetApplicationResponse, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set GetApplicationResponse value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationResponseType $getApplicationResponse
     * @return \Webservice\Service\Dto\SmevSoap\Struct\FormDataResponseType
     */
    public function setGetApplicationResponse(\Webservice\Service\Dto\SmevSoap\Struct\GetApplicationResponseType $getApplicationResponse = null)
    {
        // validation for constraint: choice(changeOrderInfo, GetApplicationQueueResponse, GetApplicationQueueReasonResponse, GetApplicationResponse, GetApplicationAdmissionResponse, cancelResponse)
        if ('' !== ($getApplicationResponseChoiceErrorMessage = self::validateGetApplicationResponseForChoiceConstraintsFromSetGetApplicationResponse($getApplicationResponse))) {
            throw new \InvalidArgumentException($getApplicationResponseChoiceErrorMessage, __LINE__);
        }
        if (is_null($getApplicationResponse) || (is_array($getApplicationResponse) && empty($getApplicationResponse))) {
            unset($this->GetApplicationResponse);
        } else {
            $this->GetApplicationResponse = $getApplicationResponse;
        }
        return $this;
    }
    /**
     * Get GetApplicationAdmissionResponse value
     * @return \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationAdmissionResponseType|null
     */
    public function getGetApplicationAdmissionResponse()
    {
        return isset($this->GetApplicationAdmissionResponse) ? $this->GetApplicationAdmissionResponse : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGetApplicationAdmissionResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetApplicationAdmissionResponse method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGetApplicationAdmissionResponseForChoiceConstraintsFromSetGetApplicationAdmissionResponse($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'changeOrderInfo',
            'GetApplicationQueueResponse',
            'GetApplicationQueueReasonResponse',
            'GetApplicationResponse',
            'cancelResponse',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property GetApplicationAdmissionResponse can\'t be set as the property %s is already set. Only one property must be set among these properties: GetApplicationAdmissionResponse, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set GetApplicationAdmissionResponse value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Webservice\Service\Dto\SmevSoap\Struct\GetApplicationAdmissionResponseType $getApplicationAdmissionResponse
     * @return \Webservice\Service\Dto\SmevSoap\Struct\FormDataResponseType
     */
    public function setGetApplicationAdmissionResponse(\Webservice\Service\Dto\SmevSoap\Struct\GetApplicationAdmissionResponseType $getApplicationAdmissionResponse = null)
    {
        // validation for constraint: choice(changeOrderInfo, GetApplicationQueueResponse, GetApplicationQueueReasonResponse, GetApplicationResponse, GetApplicationAdmissionResponse, cancelResponse)
        if ('' !== ($getApplicationAdmissionResponseChoiceErrorMessage = self::validateGetApplicationAdmissionResponseForChoiceConstraintsFromSetGetApplicationAdmissionResponse($getApplicationAdmissionResponse))) {
            throw new \InvalidArgumentException($getApplicationAdmissionResponseChoiceErrorMessage, __LINE__);
        }
        if (is_null($getApplicationAdmissionResponse) || (is_array($getApplicationAdmissionResponse) && empty($getApplicationAdmissionResponse))) {
            unset($this->GetApplicationAdmissionResponse);
        } else {
            $this->GetApplicationAdmissionResponse = $getApplicationAdmissionResponse;
        }
        return $this;
    }
    /**
     * Get cancelResponse value
     * @return \Webservice\Service\Dto\SmevSoap\Struct\CancelResponseType|null
     */
    public function getCancelResponse()
    {
        return isset($this->cancelResponse) ? $this->cancelResponse : null;
    }
    /**
     * This method is responsible for validating the value passed to the setCancelResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCancelResponse method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateCancelResponseForChoiceConstraintsFromSetCancelResponse($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'changeOrderInfo',
            'GetApplicationQueueResponse',
            'GetApplicationQueueReasonResponse',
            'GetApplicationResponse',
            'GetApplicationAdmissionResponse',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property cancelResponse can\'t be set as the property %s is already set. Only one property must be set among these properties: cancelResponse, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set cancelResponse value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Webservice\Service\Dto\SmevSoap\Struct\CancelResponseType $cancelResponse
     * @return \Webservice\Service\Dto\SmevSoap\Struct\FormDataResponseType
     */
    public function setCancelResponse(\Webservice\Service\Dto\SmevSoap\Struct\CancelResponseType $cancelResponse = null)
    {
        // validation for constraint: choice(changeOrderInfo, GetApplicationQueueResponse, GetApplicationQueueReasonResponse, GetApplicationResponse, GetApplicationAdmissionResponse, cancelResponse)
        if ('' !== ($cancelResponseChoiceErrorMessage = self::validateCancelResponseForChoiceConstraintsFromSetCancelResponse($cancelResponse))) {
            throw new \InvalidArgumentException($cancelResponseChoiceErrorMessage, __LINE__);
        }
        if (is_null($cancelResponse) || (is_array($cancelResponse) && empty($cancelResponse))) {
            unset($this->cancelResponse);
        } else {
            $this->cancelResponse = $cancelResponse;
        }
        return $this;
    }
}
